package calc;

public class AddAndSub extends Expression {
	public AddAndSub(int i) {
		super(i);
	}

	@Override
	public double accept(String expression) {
		// Left to right preference
		String matched = MatchUtil.match("^[-]?[0-9.]+[+-][-]?[0-9.]+", expression);
		String op = MatchUtil.findFirst(matched, "+", "-");
		int index = matched.indexOf(op);
		String left = matched.substring(0, index);
		String right = matched.substring(index + 1, matched.length());
		double evaluated;
		switch(op) {
			case "+":
				evaluated = evaluate(left) + evaluate(right);
				break;
			case "-":
				evaluated = evaluate(left) - evaluate(right);
				break;
			default:
				throw new IllegalStateException();
		}
		expression = expression.replace(matched, String.valueOf(evaluated));
		return evaluate(expression);
	}
}
